const axios = require('axios');

exports.request = async function(rodSession, optionAttribute,auto=false){
    
    let trancLog = 'CALL_SERVICE|__TO='.concat(optionAttribute.service || '');
        trancLog += ' __METHOD='.concat(optionAttribute.method || '');
        trancLog += ' __COMMAND='.concat(optionAttribute.command || '');
        trancLog += ' __URL='.concat(optionAttribute.url || '');
        trancLog += ' __REQID='.concat(optionAttribute.session || '');
        trancLog += ' __REQHEADERS='.concat(JSON.stringify(optionAttribute.headers) || '');
        trancLog += ' __REQBODY='.concat(JSON.stringify(optionAttribute.body) || '');
        trancLog += '|';

    let reqTime = Date.now();
    let response, errorMessage, exception;
    // let errRes = {}; 
    // let dataDetailLogReq = {};
    // let dataDetailLogRes = {};
    optionAttribute.timeout *= 1000;

    try{
        if(optionAttribute.method === 'get'){
            response = await axios.get(optionAttribute.url, {timeout: optionAttribute.timeout, headers: optionAttribute.headers,responseType: optionAttribute.responseType});
        }else if(optionAttribute.method === "put"){
            response = await axios.put(optionAttribute.url, optionAttribute.body, {timeout: optionAttribute.timeout, headers: optionAttribute.headers});
        }else if(optionAttribute.method === "post"){
            response = await axios.post(optionAttribute.url, optionAttribute.body, {timeout: optionAttribute.timeout, headers: optionAttribute.headers});
        }else if(optionAttribute.method === "delete"){
            response = await axios.delete(optionAttribute.url, {timeout: optionAttribute.timeout, headers: optionAttribute.headers});
        }
    }catch(err){ 
        // errorMessage = err.message;
        // req.error('HTTP ERROR: ' + errorMessage);
        
        if (err.response) {
            // The request was made and the server responded with a status code
            // that falls out of the range of 2xx
            response = err.response;
            // resStatusCode = response.status;
            // resHeaders = response.headers;
            // resData = response.data;
          } else if (err.request) {
            // The request was made but no response was received
            // `error.request` is an instance of XMLHttpRequest in the browser and an instance of
            // http.ClientRequest in node.js
            // response = err.request;
            // req.error('ERROR RESPONSE: ' + err.request);
            errorMessage = err.message;
            
            
            if(errorMessage.includes('ETIMEDOUT') || errorMessage.includes('timeout')) {
                exception = 'TIMEOUT';
                // errRes.data = exception;      
                // return errRes;                                
            }
            if(errorMessage.includes('ECONNREFUSED') || errorMessage.includes('socket hang up')){
                exception = 'CONNECTION_ERROR';
                // errRes.data = exception;
                // return errRes;                                                
            }
            
          } else {
            // Something happened in setting up the request that triggered an Error
            errorMessage = err.message;

          }
        //   console.log('errorConfig');
        //   console.log(error.config);    
    }
    let resTime = Date.now();
    let resTimeInMilliSec = resTime-reqTime;
    let resStatusCode, resHeaders, resBody;

    if(response  && exception !== 'TIMEOUT' && exception !== 'CONNECTION_ERROR'){
        resStatusCode = response.status;
        resHeaders = response.headers;
        resBody = response.data;
    }
  
    let responseLog = ' __RESPSTATUS='.concat(resStatusCode || '');
        responseLog += ' __RESPHEADER='.concat(JSON.stringify(resHeaders) || '');
        responseLog += ' __RESPBODY='.concat(JSON.stringify(resBody) || '');
        responseLog += ' __RESPTIME='.concat(resTimeInMilliSec);
        responseLog += ' __ERRORMESSAGE='.concat(errorMessage || '');
        responseLog += ' __EXCEPTION='.concat(exception || '');
        // responseLog += '|';

   
 
    rodSession.debug(trancLog + responseLog);
    
    if(errorMessage) {
        rodSession.error('HTTP ERROR: ' + errorMessage);
        return exception;
    }

    return response;
};
