/**
 * 
 * data_path_body //true == body typeof string
 * {
    //mask pattern
    "mask_template":{
        "msisdn":[{
            "pattern": "(^\\d{9})(?=\\d{4}$)",
            "mask_value": "***",
            "continue":true 
            
        },{
            "pattern": "xxx",
            "mask_value": "yy"
        }],
        "fbbid":[{
            "pattern": "d{9}",
            "mask_value": "*****",
            "continue":true //koi
            
        },{
            "pattern": "xxx",
            "mask_value": "yy"
        }]
    },

    "mask_data":{
        "incoming_request":{
            "callModule": { //conf/config.json.ctrl_name OR conf/config.json.METHOD + conf/config.json.cmd
                "mask":[{
                    "type":"msisdn",
                    "app_log":true,
                    "summary_log":true, 
                    "detail_log":{ 
                        "raw_data":true, 
                        "data_path": ["a.b","c.d"]
                    }
                },{
                    "type":"fbbid",
                    "app_log":true,
                    "summary_log":true, 
                    "detail_log":{ 
                        "raw_data":true, 
                        "data_path": ["a.b","c.d"]
                    }
                }]
            },
            "postExample2": { //conf/config.json.ctrl_name OR conf/config.json.METHOD + conf/config.json.cmd
                "mask":[{
                    "type":"type_msisdn",
                    "appLog":true,
                    "summary_log":true,
                    "detail_log":{
                        "raw_data":true, 
                        "path": ["a.b","c.d"]
                    }
                }]
            }
        },
    
        "outgoing_request":{
            "aaf.example": { //pm2-$env.json.env.service.$node + "." + pm2-$env.json.env.service.$node.$cmd
                "mask":[{
                    "type":"type_msisdn",
                    "appLog":true,
                    //"summary_log":true,
                    "detail_log":{
                        "raw_data":true, 
                        "path": ["a.b","c.d"]
                    }
                }]
            }
        },
    
        "incoming_response":{
            //pm2-$env.json.env.service.$node.$cmd
        },
        "outgoing_response":{
            "callModule": { //conf/config.json.ctrl_name OR conf/config.json.METHOD + conf/config.json.cmd
                "mask":[{
                    "type":"msisdn",
                    "app_log":true,
                    "summary_log":true, 
                    "detail_log":{ 
                        "raw_data":true, 
                        "data_path": ["a.b","c.d"]
                    }
                },{
                    "type":"fbbid",
                    "app_log":true,
                    "summary_log":true, 
                    "detail_log":{ 
                        "raw_data":true, 
                        "data_path": ["a.b","c.d"]
                    }
                }]
            }
    
        }
    }
}
 */
var _ = require('lodash');  
const utils = require('./utils');

function readWithPath(path, obj, cb, currentPath=0){
    path = Array.isArray(path) ? path : path.split(".");

    for (let i = currentPath; i < path.length; i++) {
        const subPath = path[i];
        if(subPath.endsWith('[]')){
            let newSubPath = subPath.slice(0, -2);  //cut []
            if(Array.isArray(obj[newSubPath])){
                for (let j = 0; j < obj[newSubPath].length; j++) {
                    if(i+1 < path.length){//
                        //send path with new array
                        readWithPath(path, obj[newSubPath][j], cb, i+1);
                    }else{
                        // console.log("+",path.join("."), obj[newSubPath][j]);
                        let newValue = cb(obj[newSubPath][j]);
                        if(newValue){
                            obj[newSubPath][j] = newValue;
                        }
                    }
                }
                obj = obj[newSubPath];
                break;

            }else if(obj[newSubPath] == undefined){
                // console.log(path.join("."), null);
            }else{
                console.log("path " + path.join(".") + " is not array");
            }
        }else{
            try {
                if(i+1 < path.length){
                    obj = obj[subPath];
                }else{
                    // console.log("+",path.join("."), obj[subPath]);
                    let newValue = cb(obj[subPath]);
                    if(newValue){
                        obj[subPath] = newValue;
                    }
                }
            } catch (error) {
            }
            
        }
    }
}

let maskCredential = function () {
    let mask_credentails;

    let init = function (_mask_credentails) {
        mask_credentails = {
            mask_template: _mask_credentails.mask_template,
            mask_data: {
                incoming_request: _mask_credentails.mask_data.incoming_request,
                outgoing_response: _mask_credentails.mask_data.outgoing_response,
                outgoing_request: _mask_credentails.mask_data.outgoing_request,
                incoming_response: _mask_credentails.mask_data.incoming_response
            }
        }

        for (let property in mask_credentails.mask_template) {
            let mask_template = mask_credentails.mask_template[property];
            for (let index = 0; index < mask_template.length; index++) {
                const element = mask_template[index];
                element.pattern = new RegExp(element.pattern);
            }
        }
    }

    let incoming_request = function (cmd, req, logger) {
        // console.log(cmd, mask_credentails.mask_data.incoming_request[cmd].mask);
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.incoming_request &&
            mask_credentails.mask_data.incoming_request[cmd] &&
            mask_credentails.mask_data.incoming_request[cmd].mask) {

            let copyHeaders = {
                ...req.headers
            }

            let body;
            if (typeof req.body === 'object') {
                // body = {
                //     ...req.body
                // }
                //DEEP COPY
                let ctype = utils.checkCType(req.get('Content-Type'));
                if(ctype === 'json'){
                    body = JSON.parse(req.rodRawData);
                }else{
                    body = JSON.parse(JSON.stringify(req.body));
                }
            } else if (typeof req.body === 'string') {
                body = req.body;
            } else {
                body = req.body;
            }

            for (let i = 0; i < mask_credentails.mask_data.incoming_request[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.incoming_request[cmd].mask[i];
                if (mask.app_log) {
                    if (mask.app_log.headers) {
                        for (let j = 0; j < mask.app_log.headers.length; j++) {
                            let headerPath = mask.app_log.headers[j];

                            if (copyHeaders[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = copyHeaders[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        copyHeaders[headerPath] = copyHeaders[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }

                            }
                        }
                    }
                    if (mask.app_log.body && body) {
                        if (typeof mask.app_log.body === 'boolean' &&
                            mask.app_log.body === true &&
                            typeof body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    body = body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.app_log.body) &&
                            typeof body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.app_log.body.length; index++) {
                                const bodyPath = mask.app_log.body[index];
                                readWithPath(bodyPath, body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }
            // console.log(copyHeaders);
            logger.writeApplogIncoming(req.sessionID, {
                method: req.method,
                url: req.url,
                headers: copyHeaders,
                body: body
            });

        } else {
            logger.writeApplogIncoming(req.sessionID, req);
        }
    }

    let incoming_request_detail = function (cmd, req, detailLog) {
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.incoming_request &&
            mask_credentails.mask_data.incoming_request[cmd] &&
            mask_credentails.mask_data.incoming_request[cmd].mask) {

            let copyHeaders = {
                ...req.headers
            }

            let body;
            let rawData = req.rodRawData;
            if (typeof req.body === 'object') {
                // rawData = Object.keys(req.body).length === 0 ? null : JSON.stringify(req.body);
                // body = {
                //     ...req.body
                // }
                //DEEP COPY
                let ctype = utils.checkCType(req.get('Content-Type'));
                if(ctype === 'json'){
                    body = JSON.parse(req.rodRawData);
                }else{
                    body = JSON.parse(JSON.stringify(req.body));
                }
                
            } else if (typeof req.body === 'string') {
                body = req.body;
                // rawData = req.body;
            } else {
                body = req.body;
                // rawData = req.body;
            }

            for (let i = 0; i < mask_credentails.mask_data.incoming_request[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.incoming_request[cmd].mask[i];
                if (mask.detail_log) {
                    //rawData
                    if (mask.detail_log.raw_data && rawData) {
                        if (mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = rawData.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    rawData = rawData.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    if (mask.detail_log.data_path_headers) {
                        for (let j = 0; j < mask.detail_log.data_path_headers.length; j++) {
                            let headerPath = mask.detail_log.data_path_headers[j];
                            if (copyHeaders[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = copyHeaders[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        copyHeaders[headerPath] = copyHeaders[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }

                            }
                        }
                    }

                    if (mask.detail_log.data_path_body && body) {
                        if (typeof mask.detail_log.data_path_body === 'boolean' &&
                            mask.detail_log.data_path_body === true &&
                            typeof body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    body = body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.detail_log.data_path_body) &&
                            typeof body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.detail_log.data_path_body.length; index++) {
                                const bodyPath = mask.detail_log.data_path_body[index];
                                readWithPath(bodyPath, body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }

            let inputCmd = detailLog.Scenario; //avoid case change cmd name
            detailLog.addInputRequest("client", inputCmd, req.invoke,
                rawData, {
                    Headers: copyHeaders,
                    Url: req.url,
                    QueryString: Object.keys(req.query).length === 0 ? null : req.query,
                    Body: body
                },
                req.protocol, req.method);

        } else {
            let rawData = null;
            if (detailLog.isRawDataEnabled()) {
                // rawData = Object.keys(req.body).length === 0 ? null : JSON.stringify(req.body);
                rawData = req.rodRawData;
            }
            let inputCmd = detailLog.Scenario; //avoid case change cmd name
            detailLog.addInputRequest("client", inputCmd, req.invoke,
                rawData, {
                    Headers: req.headers,
                    Url: req.url,
                    QueryString: Object.keys(req.query).length === 0 ? null : req.query,
                    Body: Object.keys(req.body).length === 0 ? null : req.body
                },
                req.protocol, req.method);
        }
    }

    let outgoing_response_summary = function (cmd, summary) {
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.outgoing_response &&
            mask_credentails.mask_data.outgoing_response[cmd] &&
            mask_credentails.mask_data.outgoing_response[cmd].mask &&
            summary.identity && typeof summary.identity === 'string') {


            for (let i = 0; i < mask_credentails.mask_data.outgoing_response[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.outgoing_response[cmd].mask[i];
                if (mask.summary_log === true) {
                    let mt = mask_credentails.mask_template[mask.type];
                    for (let k = 0; k < mt.length; k++) {
                        let replaced = summary.identity.search(mt[k].pattern) >= 0;
                        if (replaced) {
                            summary.identity = summary.identity.replace(mt[k].pattern, mt[k].mask_value);
                            if (mt[k].continue !== true) {
                                break;
                            }
                        }
                    }
                }
            }
        }
    }

    let outgoing_response = function (cmd, res, logger) {
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.outgoing_response &&
            mask_credentails.mask_data.outgoing_response[cmd] &&
            mask_credentails.mask_data.outgoing_response[cmd].mask) {

            let copyHeaders = {
                ...res._headers
            }
            let body; //res.body is not effect with real resp
            if (typeof res.body === 'object') {
                body = {
                    ...res.body
                }
            } else if (typeof res.body === 'string') {
                body = res.body;
            } else {
                body = res.body;
            }

            for (let i = 0; i < mask_credentails.mask_data.outgoing_response[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.outgoing_response[cmd].mask[i];
                if (mask.app_log) {
                    if (mask.app_log.headers) {
                        for (let j = 0; j < mask.app_log.headers.length; j++) {
                            let headerPath = mask.app_log.headers[j];

                            if (copyHeaders[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = copyHeaders[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        copyHeaders[headerPath] = copyHeaders[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }

                            }
                        }
                    }
                    if (mask.app_log.body && body) {
                        if (typeof mask.app_log.body === 'boolean' &&
                            mask.app_log.body === true &&
                            typeof body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    body = body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.app_log.body) &&
                            typeof body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.app_log.body.length; index++) {
                                const bodyPath = mask.app_log.body[index];
                                readWithPath(bodyPath, body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }

            // console.log(copyHeaders);
            logger.writeApplogOutgoing(res._sid, {
                statusCode: res.statusCode,
                _headers: copyHeaders,
                _processAPP: res._processAPP,
                _reqTimeForLog: res._reqTimeForLog,
                body: body
            });

        } else {
            logger.writeApplogOutgoing(null, res);
        }
    }


    let outgoing_response_detail = function (cmd, req, res, detailLog) {

        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.outgoing_response &&
            mask_credentails.mask_data.outgoing_response[cmd] &&
            mask_credentails.mask_data.outgoing_response[cmd].mask) {

            let copyHeaders = {
                ...res._headers
            }
            let rawData = null;
            if (detailLog.isRawDataEnabled() && res._rodRawData) {
                rawData = res._rodRawData;
            }

            let ctype = utils.checkCType(res.get('Content-Type'));
            if (ctype !== false) {
                res.body = utils.convertFromType(ctype, res._rodRawData);
            }

            let body = res.body;


            for (let i = 0; i < mask_credentails.mask_data.outgoing_response[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.outgoing_response[cmd].mask[i];
                if (mask.detail_log) {
                    //rawData
                    if (mask.detail_log.raw_data && rawData) {
                        if (mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = rawData.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    rawData = rawData.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    //header
                    if (mask.detail_log.data_path_headers) {
                        for (let j = 0; j < mask.detail_log.data_path_headers.length; j++) {
                            let headerPath = mask.detail_log.data_path_headers[j];

                            if (copyHeaders[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = copyHeaders[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        copyHeaders[headerPath] = copyHeaders[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    //body
                    if (mask.detail_log.data_path_body && body) {
                        if (typeof mask.detail_log.data_path_body === 'boolean' &&
                            mask.detail_log.data_path_body === true &&
                            typeof body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    body = body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.detail_log.data_path_body) &&
                            typeof body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.detail_log.data_path_body.length; index++) {
                                const bodyPath = mask.detail_log.data_path_body[index];
                                readWithPath(bodyPath, body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }

            detailLog.addOutputResponse("client", detailLog.Scenario, detailLog.InitInvoke,
                rawData, {
                    StatusCode: res.statusCode,
                    Header: copyHeaders,
                    Body: body || null
                });

            if (typeof detailLog._async !== 'function' || detailLog._async() !== true) {
                try {
                    detailLog.end();
                } catch (e) {
                    req.rodSession.error(e);
                    // console.error(1234, e);
                }
            }
        } else {
            let rawData = null;
            if (detailLog.isRawDataEnabled()) {
                if (res._rodRawData) {
                    rawData = res._rodRawData;
                }
            }
            let ctype = utils.checkCType(res.get('Content-Type'));
            if (ctype !== false) {
                res.body = utils.convertFromType(ctype, res._rodRawData);
            }

            detailLog.addOutputResponse("client", detailLog.Scenario, detailLog.InitInvoke,
                rawData, {
                    StatusCode: res.statusCode,
                    Header: res.getHeaders(),
                    Body: res.body || null
                });

            if (typeof detailLog._async !== 'function' || detailLog._async() !== true) {
                try {
                    detailLog.end();
                } catch (e) {
                    req.rodSession.error(e);
                    // console.error(1234, e);
                }
            }
        }
    }



    let outgoing_request = function (cmd, optionAttribute) {
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.outgoing_request &&
            mask_credentails.mask_data.outgoing_request[cmd] &&
            mask_credentails.mask_data.outgoing_request[cmd].mask) {

            let copyHeaders = {
                ...optionAttribute.headers
            }


            let body; 
            if (typeof optionAttribute.data === 'object') {
                // body = {
                //     ...optionAttribute.data
                // }
                body = JSON.parse(optionAttribute._rawData);//DEEP COPY

            } else if (typeof optionAttribute.data === 'string') {
                body = optionAttribute.data;
            } else {
                body = optionAttribute.data;
            }

            for (let i = 0; i < mask_credentails.mask_data.outgoing_request[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.outgoing_request[cmd].mask[i];
                if (mask.app_log) {
                    if (mask.app_log.headers) {
                        for (let j = 0; j < mask.app_log.headers.length; j++) {
                            let headerPath = mask.app_log.headers[j];
                            if (copyHeaders[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = copyHeaders[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        copyHeaders[headerPath] = copyHeaders[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }

                            }
                        }
                    }
                    if (mask.app_log.body && body) {
                        if (typeof mask.app_log.body === 'boolean' &&
                            mask.app_log.body === true &&
                            typeof body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    body = body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.app_log.body) &&
                            typeof body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.app_log.body.length; index++) {
                                const bodyPath = mask.app_log.body[index];
                                readWithPath(bodyPath, body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }

            let trancLog = '__TO='.concat(optionAttribute._service);
            trancLog += ' __METHOD='.concat(optionAttribute.method);
            trancLog += ' __COMMAND='.concat(optionAttribute._command);
            trancLog += ' __URL='.concat(optionAttribute.url);
            trancLog += ' __REQHEADERS='.concat(JSON.stringify(copyHeaders));
            trancLog += ' __REQBODY='.concat(JSON.stringify(body));
            return trancLog;

        } else {
            return null;
        }
    }

    let outgoing_request_detail = function (cmd, obj, enableRaw) {
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.outgoing_request &&
            mask_credentails.mask_data.outgoing_request[cmd] &&
            mask_credentails.mask_data.outgoing_request[cmd].mask) {

            for (let i = 0; i < mask_credentails.mask_data.outgoing_request[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.outgoing_request[cmd].mask[i];
                if (mask.detail_log) {
                    //rawData
                    if (mask.detail_log.raw_data && obj._RawData && enableRaw) {
                        if (mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = obj._RawData.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    obj._RawData = obj._RawData.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    //header
                    if (mask.detail_log.data_path_headers) {
                        for (let j = 0; j < mask.detail_log.data_path_headers.length; j++) {
                            let headerPath = mask.detail_log.data_path_headers[j];
                            if (obj.Header[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = obj.Header[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        obj.Header[headerPath] = obj.Header[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }

                            }
                        }
                    }
                    //body
                    if (mask.detail_log.data_path_body && obj.Body) {
                        if(obj._RawData){
                            obj.Body = JSON.parse(obj._RawData);//DEEP COPY
                        }else{
                            obj.Body = JSON.parse(JSON.stringify(obj.Body)); 
                        }
                        
                        if (typeof mask.detail_log.data_path_body === 'boolean' &&
                            mask.detail_log.data_path_body === true &&
                            typeof obj.Body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = obj.Body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    obj.Body = obj.Body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.detail_log.data_path_body) &&
                            typeof obj.Body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.detail_log.data_path_body.length; index++) {
                                const bodyPath = mask.detail_log.data_path_body[index];
                                readWithPath(bodyPath, obj.Body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }
            return obj;

        } else {
            return obj;
        }
    }


    let incoming_response = function (cmd, response, input, data, rawData) {
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.incoming_response &&
            mask_credentails.mask_data.incoming_response[cmd] &&
            mask_credentails.mask_data.incoming_response[cmd].mask) {

            let copyHeaders = {...response.headers};
            let body;
            if (typeof data === 'object') {
                body = JSON.parse(rawData);//DEEP COPY
            } else if (typeof data === 'string') {
                body = rawData;
            } else {
                body = rawData;
            }

            for (let i = 0; i < mask_credentails.mask_data.incoming_response[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.incoming_response[cmd].mask[i];
                if (mask.app_log) {
                    //header
                    if (mask.app_log.headers) {
                        for (let j = 0; j < mask.app_log.headers.length; j++) {
                            let headerPath = mask.app_log.headers[j];
                            if (copyHeaders[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = copyHeaders[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        copyHeaders[headerPath] = copyHeaders[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }

                            }
                        }
                    }
                    //body
                    if (mask.app_log.body && body) {
                        if (typeof mask.app_log.body === 'boolean' &&
                            mask.app_log.body === true &&
                            typeof body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    body = body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.app_log.body) &&
                            typeof body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.app_log.body.length; index++) {
                                const bodyPath = mask.app_log.body[index];
                                readWithPath(bodyPath, body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }

            let trancLog = ' __RESPSTATUS='.concat(response.status || '');
            trancLog += ' __RESPHEADER='.concat(JSON.stringify(copyHeaders));
            trancLog += ' __RESPBODY='.concat(JSON.stringify(body));
            trancLog += ' __RESPTIME='.concat(input.ResTime);
            trancLog += ' __ERRORMESSAGE='.concat(response.message || '');

            return trancLog;

        } else {
            return null;
        }
    }

    let incoming_response_detail = function (cmd, obj) {
        
        if (mask_credentails &&
            mask_credentails.mask_data &&
            mask_credentails.mask_data.incoming_response &&
            mask_credentails.mask_data.incoming_response[cmd] &&
            mask_credentails.mask_data.incoming_response[cmd].mask) {
            if (typeof obj.Body === 'object') {
                obj.Body = JSON.parse(obj._RawData);//DEEP COPY
            } else if (typeof obj.Body === 'string') {
                obj.Body = obj._RawData;
            } else {
                obj.Body = obj._RawData;
            }

            for (let i = 0; i < mask_credentails.mask_data.incoming_response[cmd].mask.length; i++) {
                let mask = mask_credentails.mask_data.incoming_response[cmd].mask[i];
                if (mask.detail_log) {
                    //rawData
                    if (mask.detail_log.raw_data && obj._RawData) {
                        if (mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = obj._RawData.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    obj._RawData = obj._RawData.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }
                        }
                    }
                    //header
                    if (mask.detail_log.data_path_headers) {
                        for (let j = 0; j < mask.detail_log.data_path_headers.length; j++) {
                            let headerPath = mask.detail_log.data_path_headers[j];
                            if (obj.Header[headerPath] && mask_credentails.mask_template[mask.type]) {
                                let mt = mask_credentails.mask_template[mask.type];
                                for (let k = 0; k < mt.length; k++) {
                                    let replaced = obj.Header[headerPath].search(mt[k].pattern) >= 0;
                                    if (replaced) {
                                        obj.Header[headerPath] = obj.Header[headerPath].replace(mt[k].pattern, mt[k].mask_value);
                                        if (mt[k].continue !== true) {
                                            break;
                                        }
                                    }
                                }

                            }
                        }
                    }
                    //body
                    if (mask.detail_log.data_path_body && obj.Body) {
                        if (typeof mask.detail_log.data_path_body === 'boolean' &&
                            mask.detail_log.data_path_body === true &&
                            typeof obj.Body === 'string' &&
                            mask_credentails.mask_template[mask.type]) {
                            let mt = mask_credentails.mask_template[mask.type];
                            for (let k = 0; k < mt.length; k++) {
                                let replaced = obj.Body.search(mt[k].pattern) >= 0;
                                if (replaced) {
                                    obj.Body = obj.Body.replace(mt[k].pattern, mt[k].mask_value);
                                    if (mt[k].continue !== true) {
                                        break;
                                    }
                                }
                            }

                        } else if (Array.isArray(mask.detail_log.data_path_body) &&
                            typeof obj.Body === 'object' &&
                            mask_credentails.mask_template[mask.type]) {
                            for (let index = 0; index < mask.detail_log.data_path_body.length; index++) {
                                const bodyPath = mask.detail_log.data_path_body[index];
                                readWithPath(bodyPath, obj.Body, (bdpValue)=>{
                                    if (bdpValue && typeof bdpValue === 'string') {
                                        let mt = mask_credentails.mask_template[mask.type];
                                        for (let k = 0; k < mt.length; k++) {
                                            let replaced = bdpValue.search(mt[k].pattern) >= 0;
                                            if (replaced) {
                                                bdpValue = bdpValue.replace(mt[k].pattern, mt[k].mask_value);
                                                if (mt[k].continue !== true) {
                                                    break;
                                                }
                                            }
                                        }
                                        return bdpValue;
                                    }
                                });
                            }
                        }
                    }
                }
            }
            return obj;

        } else {
            return obj;
        }
    }


    return {
        init,
        incoming_request,
        incoming_request_detail,

        outgoing_response,
        outgoing_response_detail,
        outgoing_response_summary,

        outgoing_request,
        outgoing_request_detail,
        incoming_response,
        incoming_response_detail
    };
}





module.exports = maskCredential();