
let queues = [];
// [
//  [{"key":"a","req":{"a":"a"}}],
//  [{"key":"b","req":{"a":"a"}}]
// ]
//    QSIZE == 3 QLVL=2
//[
//    [K1_LVL1, K2_LVL1, K3_LVL1]
//    [K1_LVL2, K2_LVL2, K3_LVL2]
//]

let correlateQueueFn;
let queueOpt = {
    maxGlobalQ : 1000,
    maxSessionQ : 10
};

function countQueue( qKey ){
    if( !qKey ){
        // //global
        let sum = 0;
        let qLVL0 = queues[0];//use lvl 0 cuz all lvl is the same req
        for (let i = 0; i < qLVL0.length; i++) {
            const q = qLVL0[i];
            if(q.req.rodQueue.next){
                sum ++;
            }
        }
        return sum;
    } else {
        let sum = 0;
        let qSize = queues[0].length //can use any index
        for (let i = 0; i < qSize; i++) { //Q SIZE 
            for (let j = 0; j < qKey.length; j++) {
                const qReq = qKey[j];
                if(qReq.key != null 
                    && qReq.key == queues[j][i].key 
                    && queues[j][i].req.rodQueue.next) { 
                    sum++;
                    break;
                }
            }
        }
        return sum;
    }
}

function rejectQ(req,res){
    return res.status(429).send("Too Many Requests");
}

function find(qKey){
    // console.log('find queue svQ=',queues,'newQ=',qKey);
    for (let i = 0; i < qKey.length; i++) {
        const qFromReq = qKey[i];
        if(qFromReq.key == null)continue;

        // console.log(11,"QKEY@LVL" , i ,"=",qFromReq);
        
        let qSV = queues[i];
        for (let indexQLVL = 0; indexQLVL < qSV.length; indexQLVL++) {
            const qLVL = qSV[indexQLVL];
            // console.log('find queue lvl',indexQLVL,qLVL);
            
            if(qLVL.key == qFromReq.key){
                // console.log('found match with key=', qLVL.key, 'at lvl',i);
                return qLVL.req;
            }
        }
    }
    return false;
}


function deQueue(qKey,req,res){
    let searchKey = qKey[0]; //fix cuz all lvl same index
    let serverQ = queues[0];
    let selectIndex = -1;
    for (let i = 0; i < serverQ.length; i++) {
        if(serverQ[i] == searchKey){
            selectIndex = i;
            break;
        }
    }
    if(selectIndex > -1){
        for (let i = 0; i < queues.length; i++) {
            queues[i].splice (selectIndex, 1);
        }
        // console.log('after deQ', queues);
        return true;
    }else{
        // console.log('after deQ', queues);
        return false;
    }

}

function enQueue(qKey,req,next){
    req.rodQueue = {
        key : qKey,
        next 
    };
    for (let i = 0; i < qKey.length; i++) {
        queues[i].push( qKey[i] );
    }
}

let enableQ = false;
let logger;
module.exports =  {
    
    init : function(_correlateQueue, envServer, _logger){
        correlateQueueFn = _correlateQueue;
        if( typeof correlateQueueFn === "function" ){
            correlateQueueFn = [correlateQueueFn];
        }
        for (let i = 0; i < correlateQueueFn.length; i++) {
            queues.push([]); //create lvl queue
        }

        if(envServer && envServer.maxGlobalQueue){
            queueOpt.maxGlobalQ = envServer.maxGlobalQueue;
        }
        if(envServer && envServer.maxSessionQueue){
            queueOpt.maxSessionQ = envServer.maxSessionQueue;
        }
        enableQ = true;
        logger = _logger;
    }, nq : function (req,res,next,appRodSession) {
        if(!enableQ) return next();

        let queueKey = [];
        let logKey = '';
        for (let index = 0; index < correlateQueueFn.length; index++) {
            let k = correlateQueueFn[index].call(appRodSession, req, res);
            logKey += k + '|';
            queueKey.push({
                "key":k, 
                req,
            });
        }
        logKey = logKey.slice(0, -1); //del | lasted
        // console.log('enQUEUE',queueKey);

        let globalQ = countQueue();
        let sessionQ = countQueue(queueKey);
        // console.log(99,`[[${req.sessionID}]]
        //     queue queueKey=${logKey}
        //     globalQueue=${globalQ}
        //     sessionQueue=${sessionQ}`);
        logger.debug(req.sessionID,`queue queueKey=${logKey} globalQueue=${globalQ} sessionQueue=${sessionQ} URL=${req.url}`);
        if( globalQ > queueOpt.maxGlobalQ || sessionQ > queueOpt.maxSessionQ ){
            logger.debug(req.sessionID,`exceeded queue limit`);
            return rejectQ(req,res);
        }

        let foundQ = find(queueKey);
        if( foundQ ){
            // console.log('found');
            logger.debug(req.sessionID,`enqueue queueKey=${logKey} URL=${req.url}`);
            enQueue(queueKey,req,next);
            // console.log(111, queues );

        } else {
            // console.log('not found');
            //add to queue cuz use for check next req
            enQueue(queueKey,req);
            // console.log(111, queues );
            return next();
        }
        
        
    },dq:function(req,res){
        if(!enableQ) return;
        
        if(req.rodQueue){
            let key = req.rodQueue.key;
            deQueue(key,req,res);
            //find next q
            let nextQ = find(key);
            if( nextQ  ){
                // console.log('next q=',nextQ.rodQueue);
                let nxt = nextQ.rodQueue.next;
                if(nxt){
                    //case  req1 k1=a k2=b | req2 k1=c k2=d | req3 k1=a k2=d
                    nextQ.rodQueue.next = undefined;
                    process.nextTick( nxt );
                }
                
            }
        }
        
    },log:()=>{
        // console.log(111, queues );
    }
};