
const httpService = require('./http-service');
let httpService2 = require('./http-service2');
const maskCredential = require('./maskCredential');

function RodSession(sessionID, logger, app, appName, _selectorServiceConf, _selectorAppConf, db) {
    // this.p = [];
    this.sessionID = sessionID;
    this.logger = logger;
    this.app = app;
    this.appName = appName;
    this._selectorServiceConf = _selectorServiceConf;
    this._selectorAppConf = _selectorAppConf;
    this.db = db;
}

// function _initServ(app){
// }

RodSession.prototype = function () {
    //find obj with path x.y.z
    function resolve(path, obj, separator='.') {
        var properties = Array.isArray(path) ? path : path.split(separator)
        return properties.reduce((prev, curr) => prev && prev[curr], obj)
    }
    let clog = function(name, logTxt){ 
        this.logger.clog(name, logTxt);
    };
    let debug = function(...args){ 
        this.logger.debug(this.sessionID, ...args);
    };
    let info = function(...args){
        this.logger.info(this.sessionID, ...args);
    };
    let warn = function(...args){
        this.logger.warn(this.sessionID, ...args);
    };
    let error = function(...args){
        this.logger.error(this.sessionID, ...args);
    };
    let summary = function(...args){
        if(args.length === 0 ){
            return this._currentSummary;
        }else{
            return this._currentSummary = this.logger.summary(this.sessionID, ...args);
        }
    };
    let detail = function(...args){
        if(args.length === 0 ){
            return this._currentDetail;
        }else{
            return this._currentDetail = this.logger.detail(this.sessionID, ...args);
        }
    };

    let waitFinished =  function(){
        let self = this;
        let promise = new Promise(function(resolve, reject){
            // setTimeout(() => resolve(" middle"), 5000)
            self._cbWaitFinished = resolve;
        });
        return promise;
    }
    
    let commonLogAsync = function(req, cmd=this.cmd, identity=""){
        commonLog.call(this, req, cmd, identity, true);
    }

    let commonLog = function(req=this.req, cmd=this.cmd, identity="", aSync=false){
        if( aSync ){
            this.detail( req.invoke, cmd, identity )._async = ()=> true;
        }else{
            this.detail( req.invoke, cmd, identity );
        }
        this.summary( req.invoke, cmd, identity )._async = aSync;
        
        maskCredential.incoming_request_detail( this.cmd, req, req.rodSession.detail() );
        // let rawData = null;
        // if(req.rodSession.detail().isRawDataEnabled()){
        //     rawData = Object.keys(req.body).length === 0 ? null : JSON.stringify(req.body)
        // }
        // this._currentDetail.addInputRequest("client", cmd, req.invoke, 
        //     rawData,
        //     {
        //         Headers: req.headers,
        //         Url: req.url,
        //         QueryString: Object.keys(req.query).length === 0 ? null : req.query,
        //         Body: Object.keys(req.body).length === 0 ? null : req.body
        //     }, 
        //     req.protocol, req.method);
    };

    // let currentSummary = function(){
    //     return this._currentSummary;
    // };
    // let currentDetail = function(){
    //     return this._currentDetail;
    // };
    let stat = function(...args){
        this.logger.stat(...args);
    };
    let setCmd = function(cmd){
        this.cmd = cmd;
    };
    let setDb = function(db){
        this.db = db;
    };
    let setExpressParam = function(expressReq, expressRes, expressNext){
        this.req = expressReq;
        this.res = expressRes;
        this.next = expressNext;
    };    

    let utils = function(){
        return this._utils || (this._utils = {
        // return (this._utils = {
            services : (svcName)=>{
                return {
                    conf : (cmd)=> {
                        return this._selectorServiceConf(svcName, cmd);
                    },
                    modules : (fnName) => {
                        this.svc = this.svc || {};
                        if(!this.svc[svcName] ){
                            this.svc[svcName] = {};
                        }
                        if(!this.svc[svcName][fnName] ){
                            let resolveModule = resolve(`${svcName}.${fnName}`,this.app.src.services);
                            if(typeof resolveModule === "function"){
                                this.svc[svcName][fnName] = resolveModule.bind(this);
                            } else{
                                this.svc[svcName][fnName] = resolveModule;
                            }
                            // if(typeof this.app.src.services[svcName][fnName] === "function"){
                            //     this.svc[svcName][fnName] = this.app.src.services[svcName][fnName].bind(this);
                            // } else{
                            //     this.svc[svcName][fnName] = this.app.src.services[svcName][fnName]
                            // }
                        }
                        return this.svc[svcName][fnName];
                    }
                }
            },

            submodules : (submodulesName)=>{
                return {
                    modules : (fnName) => {
                        this.subModules = this.subModules || {};
                        if(!this.subModules[submodulesName] ){
                            this.subModules[submodulesName] = {};
                        }
                        if(!this.subModules[submodulesName][fnName] ){
                            let resolveModule = resolve(`${submodulesName}.${fnName}`, this.app.src.submodules);
                            if(typeof resolveModule === "function"){
                                this.subModules[submodulesName][fnName] = resolveModule.bind(this);
                            } else{
                                this.subModules[submodulesName][fnName] = resolveModule;
                            }
                            // if(typeof this.app.src.services[svcName][fnName] === "function"){
                            //     this.svc[svcName][fnName] = this.app.src.services[svcName][fnName].bind(this);
                            // } else{
                            //     this.svc[svcName][fnName] = this.app.src.services[svcName][fnName]
                            // }
                        }
                        return this.subModules[submodulesName][fnName];
                    }
                }
            },

            schemas : (schemasName) => {
                this.schemasName = this.schemasName || {};
                
                if( !this.schemasName[schemasName] ){
                    let resolveSchemas = resolve(schemasName, this.app.src.schemas);
                    this.schemasName[schemasName] = resolveSchemas;
                }
                return this.schemasName[schemasName];
            },

            app : ()=>{
                return {
                    conf : (key)=>{
                        return this._selectorAppConf(key);
                    },
                    const : (key)=>{
                        return this._selectorAppConf(key,false);
                    }
                }
            },      
            https : ()=>{
                return {
                    request_old : (optionAttribute)=>{
                        return httpService.request(this, optionAttribute);
                    },
                    request : (optionAttribute)=>{
                        return httpService2.requestHttp(this, optionAttribute)
                            .catch((err)=>{
                                this.warn("this.utils().https().request", err.message);
                                return err;
                        });
                    },
                    isError : (res)=>{
                        if(Array.isArray(res)){
                            for (let i = 0; i < res.length; i++) {
                                if( typeof res[i] === 'string') return true;
                            }
                            return false;
                        }else {
                            return typeof res === 'string'
                        }
                         
                    }
                }   
            },
            http : ()=>{
                return {
                    request_old : (optionAttribute)=>{
                        return httpService.request(this, optionAttribute);
                    },
                    request : (optionAttribute)=>{
                        return httpService2.requestHttp(this, optionAttribute)
                            .catch((err)=>{
                                this.warn("this.utils().http().request", err.message);
                                return err;
                        });
                    },
                    isError : (res)=>{
                        if(Array.isArray(res)){
                            for (let i = 0; i < res.length; i++) {
                                if( typeof res[i] === 'string') return true;
                            }
                            return false;
                        }else {
                            return typeof res === 'string'
                        }
                         
                    }
                }
            },
            mongo : ()=>{
                return {
                    collection : (colName) =>{
                        if(!this.app._rod.collection[colName]){
                            this.debug("create instance mongo.collection=" + colName)
                            this.app._rod.collection[colName] = this.db.collection(colName);
                        }else{
                            // this.debug("get cache instance mongo.collection=" + colName)
                        }
                        return this.app._rod.collection[colName];
                    },
                    getDb : () => {
                        return this.db;
                    }
                }
            }
        })
    }


    return {
        clog,debug,info,warn,error,summary,detail,stat,commonLog,commonLogAsync, 
        waitFinished,
        // currentSummary,currentDetail,
        _setCmd: setCmd,
        _setDb: setDb,
        _setExpressParam: setExpressParam,
        utils,
        // mongo,collection,find,
        // http,request
    }
}();

module.exports = RodSession;
module.exports.setMock = (httpService2Mock)=>{
    httpService2 = httpService2Mock;
};
// module.exports.init = _initServ;
